'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Rule = require('../Rule');

var _Rule2 = _interopRequireDefault(_Rule);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Default element to group rules for the QueryBuilder
 */
var RuleGroup = function (_React$Component) {
    _inherits(RuleGroup, _React$Component);

    function RuleGroup(props) {
        _classCallCheck(this, RuleGroup);

        var _this = _possibleConstructorReturn(this, (RuleGroup.__proto__ || Object.getPrototypeOf(RuleGroup)).call(this, props));

        _this.onCombinatorChange = function (value) {
            var onPropChange = _this.props.onPropChange;


            onPropChange('combinator', value, _this.props.id);
        };

        _this.addRule = function (event) {
            event.preventDefault();
            event.stopPropagation();

            var _this$props = _this.props,
                createRule = _this$props.createRule,
                onRuleAdd = _this$props.onRuleAdd;


            var newRule = createRule();
            onRuleAdd(newRule, _this.props.id);
        };

        _this.addGroup = function (event) {
            event.preventDefault();
            event.stopPropagation();

            var _this$props2 = _this.props,
                createRuleGroup = _this$props2.createRuleGroup,
                onGroupAdd = _this$props2.onGroupAdd;

            var newGroup = createRuleGroup();
            onGroupAdd(newGroup, _this.props.id);
        };

        _this.removeGroup = function (event) {
            event.preventDefault();
            event.stopPropagation();

            _this.props.onGroupRemove(_this.props.id, _this.props.parentId);
        };

        return _this;
    }

    _createClass(RuleGroup, [{
        key: 'render',
        value: function render() {
            var _this2 = this;

            var _props = this.props,
                combinator = _props.combinator,
                rules = _props.rules,
                translations = _props.translations,
                onRuleRemove = _props.onRuleRemove,
                createRule = _props.createRule,
                onRuleAdd = _props.onRuleAdd,
                createRuleGroup = _props.createRuleGroup,
                onGroupAdd = _props.onGroupAdd,
                onGroupRemove = _props.onGroupRemove,
                isRuleGroup = _props.isRuleGroup,
                getLevel = _props.getLevel,
                getOperators = _props.getOperators,
                onPropChange = _props.onPropChange,
                _props$schema = _props.schema,
                combinators = _props$schema.combinators,
                controls = _props$schema.controls,
                classNames = _props$schema.classNames;

            var level = getLevel(this.props.id);
            return _react2.default.createElement(
                'div',
                { className: 'ruleGroup ' + classNames.ruleGroup },
                _react2.default.createElement(controls.combinatorSelector, {
                    options: combinators,
                    value: combinator,
                    title: translations.combinators.title,
                    className: 'ruleGroup-combinators ' + classNames.combinators,
                    handleOnChange: this.onCombinatorChange,
                    rules: rules,
                    level: level
                }),
                _react2.default.createElement(controls.addRuleAction, {
                    label: translations.addRule.label,
                    title: translations.addRule.title,
                    className: 'ruleGroup-addRule ' + classNames.addRule,
                    handleOnClick: this.addRule,
                    rules: rules,
                    level: level
                }),
                _react2.default.createElement(controls.addGroupAction, {
                    label: translations.addGroup.label,
                    title: translations.addGroup.title,
                    className: 'ruleGroup-addGroup ' + classNames.addGroup,
                    handleOnClick: this.addGroup,
                    rules: rules,
                    level: level
                }),
                this.hasParentGroup() ? _react2.default.createElement(controls.removeGroupAction, {
                    label: translations.removeGroup.label,
                    title: translations.removeGroup.title,
                    className: 'ruleGroup-remove ' + classNames.removeGroup,
                    handleOnClick: this.removeGroup,
                    rules: rules,
                    level: level
                }) : null,
                rules.map(function (r) {
                    return isRuleGroup(r) ? _react2.default.createElement(RuleGroup, { key: r.id,
                        id: r.id,
                        schema: _this2.props.schema,
                        parentId: _this2.props.id,
                        onGroupAdd: onGroupAdd,
                        getLevel: getLevel,
                        isRuleGroup: isRuleGroup,
                        createRuleGroup: createRuleGroup,
                        onGroupRemove: onGroupRemove,
                        onPropChange: onPropChange,
                        onRuleAdd: onRuleAdd,
                        onRuleRemove: onRuleRemove,
                        createRule: createRule,
                        getOperators: getOperators,
                        combinator: r.combinator,
                        translations: _this2.props.translations,
                        rules: r.rules }) : _react2.default.createElement(_Rule2.default, { key: r.id,
                        id: r.id,
                        field: r.field,
                        value: r.value,
                        getOperators: getOperators,
                        onPropChange: onPropChange,
                        getLevel: getLevel,
                        operator: r.operator,
                        schema: _this2.props.schema,
                        parentId: _this2.props.id,
                        translations: _this2.props.translations,
                        onRuleRemove: onRuleRemove });
                })
            );
        }
    }, {
        key: 'hasParentGroup',
        value: function hasParentGroup() {
            return this.props.parentId;
        }
    }]);

    return RuleGroup;
}(_react2.default.Component);

RuleGroup.propTypes = {
    /**
     * This is a callback function invoked to get the list of allowed operators for the given field
     */
    getOperators: _propTypes2.default.func,
    /**
     * This is a callback function invoked to return the current level for this rule
     */
    getLevel: _propTypes2.default.func,
    /**
     * This is a callback function invoked when a rule is removed
     */
    onRuleRemove: _propTypes2.default.func,
    /**
     * This is a callback function invoked notify this ruleGroup has made a property change for combinator
     */
    onPropChange: _propTypes2.default.func,
    /**
     * This is a callback function invoked when this RuleGroup is removed
     */
    onGroupRemove: _propTypes2.default.func,
    /**
     * This is a callback function to return a new default RuleGroup
     */
    createRuleGroup: _propTypes2.default.func,
    /**
     * This is a callback function invoked when clicking on creating a new RuleGroup
     */
    onGroupAdd: _propTypes2.default.func,
    /**
     * This is a callback function to return a new default Rule
     */
    createRule: _propTypes2.default.func,
    /**
     * This is a callback function invoked when clicking on creating a new Rule
     */
    onRuleAdd: _propTypes2.default.func,
    /**
     * This is a callback function invoked to determine if the element is a RuleGroup
     */
    isRuleGroup: _propTypes2.default.func,
    /**
     * Random generated id for rule
     */
    id: _propTypes2.default.any.isRequired,
    /**
     *  Id for the RuleGroup this RuleGroup is nested in
     */
    parentId: _propTypes2.default.any,
    /**
     * Array of current Rules
     */
    rules: _propTypes2.default.array,
    /**
     * Selected combinator value
     */
    combinator: _propTypes2.default.string.isRequired,
    /**
     * Current schema from QueryBuilder
     */
    schema: _propTypes2.default.object
};

RuleGroup.defaultProps = {
    id: null,
    parentId: null,
    rules: [],
    combinator: 'and',
    schema: {}
};

exports.default = RuleGroup;